> For the complete documentation index, see [llms.txt](https://developer.magtek.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/android/ieventsubscriber-delegates.md).

# IEventSubscriber Delegates

MTUSDKNET API will invoke the callback function in this chapter to provide the requested data and/or a detailed response. To delegate the event, call the subscribeAll function with the name of a class that implements the IEventSubscriber Delegates interface.

## OnEvent

OnEvent handles all event types. The `eventType` parameter defines which event is triggered.

```csharp
public void OnEvent( 
    EventType eventType, 
    IData data);
```

| Parameter   | Description                                                                  |
| ----------- | ---------------------------------------------------------------------------- |
| `eventType` | An enumeration indicating the event triggered by the device.                 |
| `data`      | Contains the data for the event. The payload is dependent on the event type. |

Return Value: None

**Example**

```csharp
public class OnEventClass implements IEventSubscriber
{
    public void OnEvent(EventType eventType, IData data)
    {
        // Event handler
    }

}

OnEventClass eventCallBack = new OnEventClass(); 
device.subscribeAll(evenCallBack);
```

In this example, the main window implements `IEventSubscriber`. The keyword `this` is used to pass in the name of the current class `MainWindow`.

```csharp
public partial class MainWindow implements IEventSubscriber
{
    public void OnEvent(EventType eventType, IData data)
    {
        // Event handler
    }
    
    public void connectDevice()
    {
        device.subscribeAll(this);
    }
}
```

## Event Data Parsing

Classes can be initialized by passing in the data byte array.

**Example**

```csharp
public void OnEvent(EventType eventType, IData data)
    {
        // Barcode data BarCodeData barcodeData =
BarCodeDataBuilder.GetBarCodeData(DeviceType.MMS, data.ByteArray());
 
    // Input request
    InputRequest ir = new InputRequest(data.ByteArray());
 
    // NFC data
    NFCData nfcData = NFCDataBuilder.GetNFCData(DeviceType.MMS, data.ByteArray());

    // Enhanced input request 
    EnhancedInputRequest eir = new
EnhancedInputRequest(data.ByteArray());
    List<DirectoryEntry> deList = eir.EnhancedSelectionList;
 
    }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/android/ieventsubscriber-delegates.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
